Zum Hauptinhalt springen

Quick Start with Vue Scheduler

Hinweis

This tutorial covers the Vue wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Scheduler. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with Vue.

The Vue Scheduler component is the official wrapper for DHTMLX Scheduler. This guide walks you through creating a small Vue 3 + Vite application and rendering a basic Scheduler using the trial package.

If you're new to Vue, start with the official Vue documentation.

Check a complete working project that follows this tutorial on GitHub.

Prerequisites​

  • Node.js installed
  • npm or Yarn
  • Vue 3 project (this page shows how to create one with Vite)
  • Vue Scheduler package access (evaluation or professional)

1. Create A Vue 3 Project​

Create a project with the official Vue scaffolding tool:

npm create vite@latest vue-scheduler-quick-start -- --template vue-ts
cd vue-scheduler-quick-start
npm install

If you prefer Yarn, replace the install step with yarn.

2. Install Vue Scheduler​

Install Vue Scheduler as described in the Vue Scheduler installation guide.

In this tutorial we use the evaluation package:

For evaluation:

npm install @dhtmlx/trial-vue-scheduler

or

yarn add @dhtmlx/trial-vue-scheduler

The examples below use the evaluation package. If you installed the professional package, replace imports with @dhx/vue-scheduler.

3. Add Demo Data​

Create src/demoData.ts:

src/demoData.ts
import type { Event } from "@dhtmlx/trial-vue-scheduler";

export const mainDate = new Date("2026-08-15T00:00:00Z");

export const schedulerEvents: Event[] = [
{ id: 1, start_date: new Date("2026-08-10T02:00:00Z"), end_date: new Date("2026-08-10T10:20:00Z"), text: "Product Strategy Hike" },
{ id: 2, start_date: new Date("2026-08-10T12:00:00Z"), end_date: new Date("2026-08-10T16:00:00Z"), text: "Agile Meditation and Release" },
{ id: 3, start_date: new Date("2026-08-11T06:00:00Z"), end_date: new Date("2026-08-11T11:00:00Z"), text: "Tranquil Tea Time" },
{ id: 4, start_date: new Date("2026-08-11T11:30:00Z"), end_date: new Date("2026-08-11T19:00:00Z"), text: "Sprint Review and Retreat" },
{ id: 5, start_date: new Date("2026-08-12T01:00:00Z"), end_date: new Date("2026-08-12T03:00:00Z"), text: "Kayaking Workshop" },
{ id: 6, start_date: new Date("2026-08-12T06:00:00Z"), end_date: new Date("2026-08-12T08:00:00Z"), text: "Stakeholder Sunset Yoga Session" },
{ id: 7, start_date: new Date("2026-08-12T07:00:00Z"), end_date: new Date("2026-08-12T12:00:00Z"), text: "Roadmap Alignment Walk" },
{ id: 8, start_date: new Date("2026-08-12T13:00:00Z"), end_date: new Date("2026-08-12T18:00:00Z"), text: "Mindful Team Building" },
{ id: 9, start_date: new Date("2026-08-13T01:00:00Z"), end_date: new Date("2026-08-13T18:00:00Z"), text: "Cross-Functional Expedition" },
{ id: 10, start_date: new Date("2026-08-13T14:00:00Z"), end_date: new Date("2026-08-13T20:00:00Z"), text: "User Feedback Picnic" },
{ id: 11, start_date: new Date("2026-08-14T03:00:00Z"), end_date: new Date("2026-08-14T08:00:00Z"), text: "Demo and Showcase" },
{ id: 12, start_date: new Date("2026-08-14T11:00:00Z"), end_date: new Date("2026-08-14T17:00:00Z"), text: "Quality Assurance Spa Day" },
{ id: 13, start_date: new Date("2026-08-15T01:00:00Z"), end_date: new Date("2026-08-15T03:00:00Z"), text: "Motion Cycling Adventure" },
{ id: 14, start_date: new Date("2026-08-15T10:00:00Z"), end_date: new Date("2026-08-15T16:00:00Z"), text: "Competitor Analysis Beach Day" },
{ id: 15, start_date: new Date("2026-08-16T02:00:00Z"), end_date: new Date("2026-08-16T06:00:00Z"), text: "Creativity Painting Retreat" },
];

4. Create A Scheduler Component​

Create src/components/Scheduler.vue:

src/components/Scheduler.vue
<script setup lang="ts">
import { ref } from "vue";
import {
VueScheduler,
type Event,
type SchedulerConfig,
type VueSchedulerDataConfig,
} from "@dhtmlx/trial-vue-scheduler";
import "@dhtmlx/trial-vue-scheduler/dist/vue-scheduler.css";
import { mainDate, schedulerEvents } from "../demoData";

const events = ref<Event[]>(schedulerEvents);

const config: SchedulerConfig = {
first_hour: 6,
last_hour: 22,
};

const data: VueSchedulerDataConfig = {
save: (entity, action, item, id) => {
console.log("[data.save]", entity, action, item, id);
},
};
</script>

<template>
<div :style="{ height: '100vh', width: '100vw' }">
<VueScheduler :events="events" :date="mainDate" view="week" :config="config" :data="data" />
</div>
</template>

If you use the professional package, replace both imports:

  • @dhtmlx/trial-vue-scheduler -> @dhx/vue-scheduler
  • @dhtmlx/trial-vue-scheduler/dist/vue-scheduler.css -> @dhx/vue-scheduler/dist/vue-scheduler.css

5. Render Scheduler In The App Shell​

Replace the default content in src/App.vue:

src/App.vue
<script setup lang="ts">
import Scheduler from "./components/Scheduler.vue";
</script>

<template>
<Scheduler />
</template>

6. Start The App​

Run the dev server:

npm run dev

Open the local URL printed by Vite. You should see Scheduler rendered in week view with the demo events.

7. (Optional) Replace Logging With Local Save Handling​

Use this when you want Vue state to stay in sync with scheduler edits before adding a backend or store. Update src/components/Scheduler.vue.

const data: VueSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
events.value = [...events.value, item as Event];
return;
}

if (action === "update") {
events.value = events.value.map(event => (event.id === id ? { ...(item as Event) } : event));
return;
}

if (action === "delete") {
events.value = events.value.filter(event => event.id !== id);
}
}
};

Result​

You now have a Vue 3 app rendering the official Vue Scheduler wrapper with:

  • reactive events props
  • data.save callback wiring for user edits

GitHub demo repository​

A complete working project that follows this tutorial is provided on GitHub.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Zum Hauptinhalt springen

Schneller Einstieg mit React Scheduler

Hinweis

Dieses Tutorial behandelt den in den Commercial, Enterprise, and Ultimate-Editionen von DHTMLX Scheduler enthaltenen React-Wrapper. Wenn Sie die Individual- oder GPL-Edition verwenden, folgen Sie der alternativen Anleitung: Wie man mit React beginnt.

Der React Scheduler-Komponenten ist der offizielle Wrapper für DHTMLX Scheduler. Diese Anleitung führt Sie durch die Erstellung einer kleinen React-Anwendung und das Rendern eines Basis-Schedulers mit dem Trial-Paket.

Wenn Sie neu bei React sind, beginnen Sie mit der offiziellen React-Dokumentation. Prüfen Sie ein vollständiges funktionsfähiges Projekt, das dieser Anleitung folgt auf GitHub.

Versionsanforderungen​

  • React 18 oder neuer

Erstellung eines neuen React-Projekts​

Um ein React-Projekt zu erstellen und in das Projektverzeichnis zu wechseln, führen Sie die folgenden Befehle aus:

npm create vite@latest react-scheduler-quick-start -- --template react-ts
cd react-scheduler-quick-start

Installation von React Scheduler​

Installieren Sie React Scheduler gemäß dem Installationsleitfaden für React Scheduler.

In diesem Tutorial verwenden wir das Evaluationspaket:

npm install @dhtmlx/trial-react-scheduler

oder

yarn add @dhtmlx/trial-react-scheduler

Wenn Sie bereits das Professional-Paket verwenden, ersetzen Sie @dhtmlx/trial-react-scheduler in den Befehlen und Importen durch @dhx/react-scheduler.

Demo-Daten hinzufügen​

Wir verwenden in diesem Beispiel statische Daten. Erstellen Sie eine Datei mit dem Namen src/demoData.ts:

import type { Event } from '@dhtmlx/trial-react-scheduler';

export const events: Event[] = [
{
id: 1,
classname: 'blue',
start_date: new Date('2025-12-08T02:00:00Z'),
end_date: new Date('2025-12-08T10:20:00Z'),
text: 'Product Strategy Hike',
},
{
id: 2,
classname: 'blue',
start_date: new Date('2025-12-08T12:00:00Z'),
end_date: new Date('2025-12-08T16:00:00Z'),
text: 'Agile Meditation and Release',
},
{
id: 3,
classname: 'violet',
start_date: new Date('2025-12-09T06:00:00Z'),
end_date: new Date('2025-12-09T11:00:00Z'),
text: 'Tranquil Tea Time',
},
// ....
];

Erstellung einer Scheduler-Komponente​

Um eine Scheduler-Komponente hinzuzufügen, erstellen Sie eine Datei src/components/Scheduler/Scheduler.tsx mit folgendem Inhalt:

import { useMemo, useRef } from 'react';
import ReactScheduler, {
type ReactSchedulerRef,
type Event,
type SchedulerTemplates,
type SchedulerConfig,
} from '@dhtmlx/trial-react-scheduler';
import '@dhtmlx/trial-react-scheduler/dist/react-scheduler.css';
import './styles.css';

export interface ReactSchedulerProps {
events: Event[];
activeView?: string;
activeDate?: Date;
}

export default function Scheduler({
events,
activeView = 'week',
activeDate = new Date('2025-12-08T00:00:00Z'),
}: ReactSchedulerProps) {
const schedulerRef = useRef<ReactSchedulerRef>(null);

const templates: SchedulerTemplates = useMemo(
() => ({
event_class: (start: Date, end: Date, event: Event) => {
return event.classname || '';
},
}),
[]
);

const config: SchedulerConfig = useMemo(() => {
return {
first_hour: 6,
last_hour: 22,
hour_size_px: 60,
};
}, []);

return (
<ReactScheduler
ref={schedulerRef}
events={events}
view={activeView}
date={activeDate}
templates={templates}
config={config}
data={{
save: (entity: string, action: string, data: Event, id: string | number) => {
console.log(`${entity} - ${action} - ${id}`, data);
},
}}
/>
);
}

Schließlich werden die CSS-Klassen (.violet, .green, .yellow) über das event_class-Template angewendet, um das visuelle Erscheinungsbild der Ereignisse anzupassen:

.violet {
--dhx-scheduler-event-background: linear-gradient(180deg, #d071ef 0%, #ee71d5 100%);
}
.green {
--dhx-scheduler-event-background: linear-gradient(180deg, #12d979 0%, #1ecdeb 100%);
}
.yellow {
--dhx-scheduler-event-background: linear-gradient(180deg, #ffb725 0%, #ffbb25 31.25%, #faea27 100%);
}

Scheduler in der App rendern​

Um Scheduler anzuzeigen, ersetzen Sie den Code von src/App.tsx durch den folgenden Code:

import './App.css';
import Scheduler from './components/Scheduler/Scheduler';
import { events } from './demoData';

function App() {
return (
<div style={{ width: '100vw', height: '100vh' }}>
<Scheduler events={events} />
</div>
);
}

export default App;

Führen Sie die App anschließend mit dem untenstehenden Befehl aus:

npm run dev

Damit haben Sie eine voll funktionsfähige React + DHTMLX Scheduler-Anwendung.

Dieses Setup repräsentiert die minimale Konfiguration, die benötigt wird, um:

  • einen Scheduler zu rendern
  • Ereignisse anzuzeigen
  • eine grundlegende Skalenkonfiguration anzuwenden
  • die Scheduler-Instanz über ein React-Ref zu attachen
  • Ereignisse über den data.save-Callback zu empfangen

Dies ist dasselbe minimale Beispiel, das im GitHub-Demo-Projekt verwendet wird.

Von hier aus können Sie mit weiteren fortgeschrittenen Funktionen fortfahren:

  • Synchronisierung von Daten mit dem React-Zustand
  • Laden/Speichern von Daten aus Ihrem Backend
  • Hinzufügen von Vorlagen und benutzerdefinierten Renderern
  • Hinzufügen von Filtern
  • Ersetzen des Lightbox durch eine benutzerdefinierte Komponente

Die nächsten Abschnitte führen diese Fähigkeiten der Reihe nach ein.

Verwendung des React-Zustands als zentrale Quelle der Daten​

(empfohlen für die meisten React-Apps)

In echten Anwendungen stammen Ereignisse normalerweise aus dem React-Zustand. Nachfolgend ein vollständiges Beispiel, bei dem der Scheduler Änderungen über den data.save-Callback an React zurücksendet.

import { useState } from 'react';
import ReactScheduler, { Event } from '@dhtmlx/trial-react-scheduler';
import '@dhtmlx/trial-react-scheduler/dist/react-scheduler.css';
import { events as initialEvents } from './demoData';

export default function App() {
const [events, setEvents] = useState<Event[]>(initialEvents);

const data = {
save: (entity, action, item, id) => {
if (entity === 'event') {
if (action === 'create') setEvents((prev) => [...prev, item]);
if (action === 'update') setEvents((prev) => prev.map((x) => (x.id === id ? item : x)));
if (action === 'delete') setEvents((prev) => prev.filter((x) => x.id !== id));
}
},
};

return (
<div style={{ height: '100vh', width: '100vw' }}>
<ReactScheduler
events={events}
data={data}
// ...andere Props
/>
</div>
);
}

Warum diesen Modus wählen​

  • React sieht immer dieselben Daten wie die Scheduler-Benutzeroberfläche
  • Funktioniert perfekt mit Redux / Zustand / Jotai / MobX
  • Einfach mit Backend-APIs zu synchronisieren

Alternativer Modus: Scheduler als Quelle der Wahrheit​

(nützlich für sehr große Datensätze)

In diesem Modus besitzt React keine Ereignisse.

<ReactScheduler
data={{
load: '/api/data', // Scheduler lädt anfängliche Ereignisse von hier
save: '/api/data', // Scheduler sendet Updates hierher zurück
}}
/>

Wann man diesen Modus bevorzugt​

  • Zehntausende von Ereignissen
  • Häufige Benutzerinteraktionen und Aktualisierungen
  • Sie möchten minimalen React-Renderaufwand

Vorlagen verwenden​

(React-Elemente aus Vorlagenfunktionen zurückgeben)

Vorlagen ermöglichen es, fast jeden Teil des Schedulers anzupassen.

import ReactScheduler, { SchedulerTemplates } from '@dhtmlx/trial-react-scheduler';
import { useMemo } from 'react';
import EventTextBox from './components/EventTextBox';

const templates: SchedulerTemplates = useMemo(
() => ({
event_class: (start, end, event) => {
return 'templates-' + event.classname || '';
},
event_text: (start, end, event) => {
return <EventTextBox event={event} />;
},
}),
[]
);

<ReactScheduler templates={templates} />;

Weitere Details​

Siehe den vollständigen Abschnitt hier: React Scheduler Templates Documentation.

GitHub-Demo-Repository​

Ein vollständiges funktionsfähiges Projekt, das dieser Anleitung folgt, ist auf GitHub verfügbar.

Nächste Schritte​

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Zum Hauptinhalt springen

Quick Start with Angular Scheduler

Hinweis

This tutorial covers the Angular wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Scheduler. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with Angular.

This guide renders a working Angular Scheduler in a standalone Angular application. It creates Scheduler inside a dedicated Angular component and mounts that component in the app shell.

Check a complete working project that follows this tutorial on GitHub.

1. Create An Angular Project​

Create a standalone Angular app (Angular CLI):

ng new angular-scheduler-quick-start --standalone --routing=false --style=css
cd angular-scheduler-quick-start

If Angular CLI is not installed yet, install it first (npm install -g @angular/cli).

2. Install Angular Scheduler​

Install Angular Scheduler as described in the installation guide.

In this tutorial we use the evaluation package:

npm install @dhtmlx/trial-angular-scheduler

or

yarn add @dhtmlx/trial-angular-scheduler

If you already use the Professional package, replace @dhtmlx/trial-angular-scheduler with @dhx/angular-scheduler in the commands and imports.

3. Add Global Styles​

Open src/styles.css and add the Scheduler styles:

src/styles.css
@import "@dhtmlx/trial-angular-scheduler/dist/angular-scheduler.css";

html,
body {
height: 100%;
margin: 0;
}

app-root {
display: block;
height: 100vh;
}

This quick start uses a global CSS import, so you do not need ViewEncapsulation.None in the Scheduler component.

If you later move the Scheduler CSS import or overrides for internal Scheduler classes into a component stylesheet, Angular's default style encapsulation may scope those selectors. In that case, set encapsulation: ViewEncapsulation.None on that component, or keep the styles global.

4. Add Demo Data​

Create src/app/demo-data.ts:

src/app/demo-data.ts
import type { Event } from "@dhtmlx/trial-angular-scheduler";

export const mainDate = new Date("2026-08-15T00:00:00Z");

export const schedulerEvents: Event[] = [
{ id: 1, start_date: new Date("2026-08-10T02:00:00Z"), end_date: new Date("2026-08-10T10:20:00Z"), text: "Product Strategy Hike" },
{ id: 2, start_date: new Date("2026-08-10T12:00:00Z"), end_date: new Date("2026-08-10T16:00:00Z"), text: "Agile Meditation and Release" },
{ id: 3, start_date: new Date("2026-08-11T06:00:00Z"), end_date: new Date("2026-08-11T11:00:00Z"), text: "Tranquil Tea Time" },
{ id: 4, start_date: new Date("2026-08-11T11:30:00Z"), end_date: new Date("2026-08-11T19:00:00Z"), text: "Sprint Review and Retreat" },
{ id: 5, start_date: new Date("2026-08-12T01:00:00Z"), end_date: new Date("2026-08-12T03:00:00Z"), text: "Kayaking Workshop" },
{ id: 6, start_date: new Date("2026-08-12T06:00:00Z"), end_date: new Date("2026-08-12T08:00:00Z"), text: "Stakeholder Sunset Yoga Session" },
{ id: 7, start_date: new Date("2026-08-12T07:00:00Z"), end_date: new Date("2026-08-12T12:00:00Z"), text: "Roadmap Alignment Walk" },
{ id: 8, start_date: new Date("2026-08-12T13:00:00Z"), end_date: new Date("2026-08-12T18:00:00Z"), text: "Mindful Team Building" },
{ id: 9, start_date: new Date("2026-08-13T01:00:00Z"), end_date: new Date("2026-08-13T18:00:00Z"), text: "Cross-Functional Expedition" },
{ id: 10, start_date: new Date("2026-08-13T14:00:00Z"), end_date: new Date("2026-08-13T20:00:00Z"), text: "User Feedback Picnic" },
{ id: 11, start_date: new Date("2026-08-14T03:00:00Z"), end_date: new Date("2026-08-14T08:00:00Z"), text: "Demo and Showcase" },
{ id: 12, start_date: new Date("2026-08-14T11:00:00Z"), end_date: new Date("2026-08-14T17:00:00Z"), text: "Quality Assurance Spa Day" },
{ id: 13, start_date: new Date("2026-08-15T01:00:00Z"), end_date: new Date("2026-08-15T03:00:00Z"), text: "Motion Cycling Adventure" },
{ id: 14, start_date: new Date("2026-08-15T10:00:00Z"), end_date: new Date("2026-08-15T16:00:00Z"), text: "Competitor Analysis Beach Day" },
{ id: 15, start_date: new Date("2026-08-16T02:00:00Z"), end_date: new Date("2026-08-16T06:00:00Z"), text: "Creativity Painting Retreat" },
];

5. Create A Scheduler Component​

Create src/app/scheduler.component.ts:

src/app/scheduler.component.ts
import { Component } from "@angular/core";
import {
DhxSchedulerComponent,
type AngularSchedulerDataConfig,
type Event,
type SchedulerConfig,
} from "@dhtmlx/trial-angular-scheduler";
import { mainDate, schedulerEvents } from "./demo-data";

@Component({
selector: "app-scheduler",
standalone: true,
imports: [DhxSchedulerComponent],
host: { style: "display:block;height:100%;" },
template: `
<dhx-scheduler
[events]="events"
[date]="date"
[config]="config"
[data]="dataConfig"
view="week">
</dhx-scheduler>
`,
})
export class SchedulerComponent {
events: Event[] = schedulerEvents;
date = mainDate;

config: SchedulerConfig = {
first_hour: 6,
last_hour: 22,
};

dataConfig: AngularSchedulerDataConfig = {
save: (entity, action, data, id) => {
console.log("[data.save]", entity, action, data, id);
},
};
}

6. Render Scheduler In The App Shell​

Replace src/app/app.ts:

src/app/app.ts
import { Component } from "@angular/core";
import { SchedulerComponent } from "./scheduler.component";

@Component({
selector: "app-root",
standalone: true,
imports: [SchedulerComponent],
template: `<app-scheduler></app-scheduler>`,
})
export class App {}

If your Angular project uses app.component.ts instead of app.ts, apply the same component code there and keep the class name expected by your main.ts.

7. Start The App​

ng serve

Open http://localhost:4200. You should see Scheduler rendered in week view with the demo events. Edits will be logged through data.save.

If you are adding Scheduler to an existing app, keep your current app shell and place <app-scheduler> in the target page or route component. Make sure the parent layout provides a height to the Scheduler area.

Optional: Minimal Local Save Handling​

As a next step, replace logging with local array synchronization:

src/app/scheduler.component.ts
dataConfig: AngularSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
this.events = [...this.events, item as Event];
return;
}

if (action === "update") {
this.events = this.events.map(event =>
String(event.id) === String(id) ? { ...(item as Event) } : event
);
return;
}

if (action === "delete") {
this.events = this.events.filter(event => String(event.id) !== String(id));
}
},
};

For grouped updates, prefer data.batchSave and handle all changes in one state transaction.

GitHub demo repository​

A complete working project that follows this tutorial is provided on GitHub.

Continue With​

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.